﻿namespace Ozeki
{
    public record OzHfDownloadDetails(int numberOfFiles, long TotalDownload, long AvalaibleSpace, IEnumerable<OzHfDownloadManifest> DownloadManifests, IEnumerable<OzHfDownloadManifest> SelectedManifests, long AlreadyDownloadedSpace = 0)
    {
        public static string FileSizeToString(long size)
        {
            var value = size;
            if (value == 0) { return string.Format("{0:n" + 0 + "} bytes", 0); }
            var mag = (int)Math.Log(value, 1024);
            if (mag < 0)
            {
                mag = 0;
            }
            var adjustedSize = (decimal)value / (1L << (mag * 10));

            string[] SizeSuffixes = { "B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB" };

            return string.Format("{0:n" + 2 + "} {1}",
                adjustedSize,
                SizeSuffixes[mag]);
        }
    }
}
