﻿namespace Ozeki
{
    internal class OzHfHuggingFaceRepository
    {
        string _baseLocation = "C:/AIModels";
        const string BaseUrl = "https://huggingface.co/";
        string _id;
        IEnumerable<string> _filesToDownload;
         
        internal OzHfHuggingFaceRepository(string id, IEnumerable<string> files)
        {
            _id = id;
            _filesToDownload = files;
        }

        internal void setOutputLocation(string location)
        {
            _baseLocation = location;
        }

        
        private OzHfDownloadManifest createManifest(string file)
        {          
            var downloadurl = BaseUrl + _id + "/resolve/main/" + file;
            var outputfile = _baseLocation + "/" + _id + "/" + file;
            var checksumUrl = BaseUrl + _id + "/raw/main/" + file;
            return new OzHfDownloadManifest(downloadurl, file, outputfile, checksumUrl, 0);
        }

        internal IEnumerable<OzHfDownloadManifest> GetAllManifest()
        {
            return _filesToDownload.AsParallel().Select(createManifest);
        }
    }
}
